//1005,"skrzatMenZnacz.sc","Skrzat - meneder znacznikw",1.03,SYSTEM
//(c)2008 SAGE Symfonia

#include "dbutil.sci"

#define DALEJ		2
#define WROC		3
#define ANULUJ -1

// ograniczenia na liczb znacznikw
#define MINZNACZ   16
#define MAXZNACZ	128



int bZnaczniki = DbOpen( "AMXTFK",1),eZnaczniki


// indeks pierwszej prezentowanej grupy znacznikw
	int nCmbZnacz   = 1

// bieca ilo znacznikw w wybranej grupie
	int nZnaczCount = 0

// podana ilo znacznikw w wybranej grupie
	int nZnacz = MINZNACZ

// parametry okna skrzata
	int nCX = 380
	int nCY = 200
	string strTitle = "  Manager znacznikw Finanse i Ksigowo"

// tablica identyfikatorw rekordw znacznikw z wybranej grupy
	long lZnaczniki(MAXZNACZ)

//string strFirma = KatalogFirmy() + "firma."+firma.code
//string sAmfmIni = KatalogWin()   + "am"+firma.code+".ini"
string cmbBoxZnacz(6)
long   lGrupy(6)


// tablica nazw grup
  	cmbBoxZnacz(1) = "Dokumenty"
	cmbBoxZnacz(2) = "Transakcje"
	cmbBoxZnacz(3) = "Rejestry"
	cmbBoxZnacz(4) = "Kontrahenci"
	cmbBoxZnacz(5) = "Pracownicy"
	cmbBoxZnacz(6) = "Urzdy"
// tablica identyfikatorw grup
	lGrupy(1)			=  100
	lGrupy(2)			=  200
	lGrupy(3)			=  101
	lGrupy(4)			=  110
	lGrupy(5)			=  120
	lGrupy(6)			=  130 


int sub WybierzZnaczniki()

 Form strTitle,nCX,nCY

	Group "Prosz wskaza grup znacznikw do rozbudowania",30,10,295,44

	Text "   Grupa znacznikw : ",60,29,110,14
	CmbBox "",cmbBoxZnacz,nCmbZnacz,170,25,100,140

//	Button "< W&r", 110,140,70,25,WROC
	Button "&Dalej >",180,140,70,25,DALEJ
	Button "&Anuluj", 260,140,70,25,ANULUJ

	WybierzZnaczniki = ExecForm

endsub

int sub PodajIlosc()

 Form strTitle,nCX,nCY

	Text (using "Grupa  '%s'  zawiera obecnie %d znacznikw",cmbBoxZnacz(nCmbZnacz), nZnaczCount),40,10,270,20

	Group "  Prosz poda podan ilo znacznikw w grupie ",30,35,295,44


	Text "Ilo znacznikw w grupie: ",100,55,150,14

	Edit "", nZnacz,250,52,40,20

	Text (using "UWAGA: W kadej wskazanej grupie ilo znacznikw musi zawiera si w przedziale <%d,%d>.",MINZNACZ,MAXZNACZ),40,95,270,40

	Button "< W&r", 110,140,70,25,WROC
	Button "&Dalej >",180,140,70,25,DALEJ
	Button "&Anuluj", 260,140,70,25,ANULUJ

	PodajIlosc = ExecForm

endsub


int sub Zapytaj()
	if nZnacz < MINZNACZ then nZnacz = MINZNACZ
	if nZnacz > MAXZNACZ then nZnacz = MAXZNACZ

 Form strTitle,nCX,nCY

	if nZnacz == nZnaczCount then
		Group (using "  Zmiana iloci znacznikw w grupie '%s'  ",cmbBoxZnacz(nCmbZnacz)),10,10,355,96
		Text (using "Podana ilo znacznikw (%d) jest rwna ich obecnej iloci.",nZnaczCount),20,29,300,15

		if ( nZnacz < MAXZNACZ ) then
			Text (using "Aby zwikszy ich ilo prosz poda warto wiksz od %d.",nZnacz),20,55,320,15
		endif
		if ( nZnacz > MINZNACZ ) then
			Text (using "Aby zmniejszy ich ilo prosz poda warto mniejsz od %d.",nZnacz),20,70,320,15
		endif

//		Text "Prosz poda inn ilo.",20,66,280,14

	else
	  if nZnacz < nZnaczCount then
			Group "  Zmiana iloci znacznikw w wybranej grupie ",10,10,355,76
			Text (using "Ilo znacznikw w grupie '%s' zostanie ZMNIEJSZONA\nz obecnych %d do %d.",cmbBoxZnacz(nCmbZnacz), nZnaczCount, nZnacz),20,29,320,30
		else
			Group "  Zmiana iloci znacznikw w wybranej grupie ",10,10,355,76
			Text (using "Ilo znacznikw w grupie '%s' zostanie ZWIKSZONA\nz obecnych  %d  do  %d.",cmbBoxZnacz(nCmbZnacz), nZnaczCount, nZnacz),20,29,320,30
		endif

		Text "Prosz o  POTWIERDZENIE  operacji.",20,66,280,14


	endif

	Button "< W&r", 110,140,70,25,WROC
	if nZnacz != nZnaczCount then
	  Button "Potwierdzam",180,140,70,25,DALEJ
	endif
	Button "&Anuluj", 260,140,70,25,ANULUJ

	Zapytaj = ExecForm

endsub

// maksymalna ilo znalezionych znacznikw
int nMaxFound = 0

int sub UstawId(int indeks, long lId)
	if indeks < 1 then
		Message using "Bdny (za niski) indeks znacznika id=%l",lId
		exit
	endif

	if indeks > MAXZNACZ then
		Message using "Bdny (za wysoki) indeks znacznika id=%l",lId
		exit
	endif

	if ( lZnaczniki(indeks) != 0 ) then 
		Message using "Zduplikowany znacznik o id=%l", lId
		exit
	endif

	if nMaxFound < indeks then nMaxFound = indeks

	lZnaczniki(indeks) = lId
	
	UstawId = indeks	
endsub

int sub UsunZnaczniki()

	int err, i
	int nUsun = nZnaczCount
	int nWartPola
	int blad
	//for i=nZnacz+1 to i > nZnaczCount
	SetKey( bZnaczniki, "id" )
	blad = GetRec( bZnaczniki , LS ) 

	while !blad
	
		nWartPola = GetField( bZnaczniki, "super")
		if nWartPola == lGrupy( nCmbZnacz ) then
			err = DelRec( bZnaczniki )
			if err != 0 then exit
				nUsun = nUsun-1
		endif
		blad = GetRec( bZnaczniki, PR )
		if nUsun<= nZnacz then exit
	wend
	//next i


  Form strTitle,nCX,nCY
		Group "",10,5,355,36
		Text (using "Ilo znacznikw w grupie '%s' zmniejszono do %d.",cmbBoxZnacz(nCmbZnacz), nUsun),20,20,300,15
	  Button "OK",180,140,70,25,DALEJ

  	Text "UWAGA! Program zawiera posta graficzn tylko dla 37 znacznikw.",20,50,340,15
		Text "Aby j rozbudowa, naley :",20,75,340,15
		Text "1. Przygotowa odpowiedni plik BMP o nazwie ZNACZNIK.BMP.",20,90,340,15
		Text "2. Wkopiowa ten plik do katalogu programu.",20,105,340,15
		Text "3. Uruchomi ponownie program.",20,120,340,15

	ExecForm

endsub

int sub DodajZnaczniki()
	int i
	int err=0
	int nLastInserted=0
	for i=nZnaczCount to i >= nZnacz
		SetKey( bZnaczniki, "id" )
		SetKeySeg( bZnaczniki, "id", 0 )
		Clear(bZnaczniki)
		SetField( bZnaczniki, "flag", 128 )
		SetField( bZnaczniki, "subtyp", using "%d",i+64 ) 
		SetField( bZnaczniki, "typ", using "%d",34 )
		SetField( bZnaczniki, "super", lGrupy( nCmbZnacz ) )
		SetField( bZnaczniki, "kod", using "znacznik %d", i+1 )
		InsRec( bZnaczniki )

		if err != 0 then exit
		nLastInserted = i
	next i
	
	PutRec( bZnaczniki )

  Form strTitle,nCX,nCY
		Group "",10,5,355,36
		Text (using "Ilo znacznikw w grupie '%s' zwikszono do %d.",cmbBoxZnacz(nCmbZnacz), nLastInserted+1),20,20,300,15
	  Button "OK",180,140,70,25,DALEJ

  	Text "UWAGA! Program zawiera posta graficzn tylko dla 37 znacznikw.",20,50,340,15
		Text "Aby j rozbudowa, naley :",20,75,340,15
		Text "1. Przygotowa odpowiedni plik BMP o nazwie ZNACZNIK.BMP.",20,90,340,15
		Text "2. Wkopiowa ten plik do katalogu programu.",20,105,340,15
		Text "3. Uruchomi ponownie program.",20,120,340,15

	ExecForm

endsub


int sub Modyfikuj()

	int i

// czycimy tablic identyfikatorw znacznikw
	for i=1 to i > size (lZnaczniki)
		lZnaczniki(i) = 0
	next i

// wypeniamy j aktualnymi danymi
	long lGrupa = lGrupy(nCmbZnacz)

	SetKey( bZnaczniki, "id" )
	
	nMaxFound = 0

	string index
	int err = GetRec( bZnaczniki, FS )

	while !err
		if lGrupa != GetField( bZnaczniki, "super" ) then exit
				index = GetField( bZnaczniki, "subtyp" )
		if index == "0" then
			UstawId(1,GetField( bZnaczniki, "id" ) )
		else
			UstawId(index-63,GetField( bZnaczniki, "id" ) )
		endif	
		err = GetRec( bZnaczniki, NX )
	wend

// sprawdzenie poprawnoci tablicy identyfikatorw
	for i=1 to i > nMaxFound
		if lZnaczniki(i) == 0 then Message using "Brak znacznika o indeksie %d",i
	next i

// wykonaj
  if nZnacz < nZnaczCount then
		UsunZnaczniki()
	else
		DodajZnaczniki()
	endif
	
endsub

// ptla skrzata
	
	

	int nRetVal = DALEJ
	int err
	int wartosc
	
	while nRetVal != ANULUJ	
		
		nZnaczCount = 0
		nRetVal = WybierzZnaczniki()
	
		if nRetVal == ANULUJ then exit
	  
		
		SetKey( bZnaczniki, "id" )
		err = GetRec( bZnaczniki, FS )
		while !err
			wartosc = GetField( bZnaczniki, "super")
			if wartosc == lGrupy( nCmbZnacz ) then 
				nZnaczCount = nZnaczCount +1
			endif	
			err = GetRec( bZnaczniki, NX )	
		wend
		
	  nZnacz = nZnaczCount
		

		while nRetVal != ANULUJ
			nRetVal = PodajIlosc()

			if nRetVal == DALEJ then 
				nRetVal = Zapytaj()
				if nRetVal == DALEJ then 
					Modyfikuj()
					exit
				endif
			else
				if nRetVal == WROC then exit
			endif
		wend
	wend
	
	DbClose(bZnaczniki)
	

Error ""
